VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Mathematics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum ntDateNFO
    ntHHMMSS = 1
    ntMMSS = 2
End Enum

Public Enum bbBit
    bb_4_BIT = 0
    bb_8_BIT = 1
    bb_16_BIT = 2
    bb_31_BIT = 3
End Enum

Public Enum BYTEISINFO
    biBytes = 0
    biKiloBytes = 1
    biMegaBytes = 2
    biGigaBytes = 3
End Enum

Public Type BYTEINFOS
    Bytes      As Variant
    KiloBytes  As Variant
    MegaBytes  As Variant
    GigaBytes  As Variant
End Type

Public Function DecToBin(ByVal Dec As Long) As String
    Dim x As Integer

    If Dec >= 2 ^ 32 Then
        DecToBin = "-1"
        Exit Function
    End If
    
    Do
        If (Dec And 2 ^ x) Then
            DecToBin = "1" & DecToBin
        Else
            DecToBin = "0" & DecToBin
        End If
        
        x = x + 1
    Loop Until 2 ^ x > Dec

End Function
Public Function HexToDec(ByVal Hex As String) As Long
    
    HexToDec = Val("&H" & Hex)

End Function
Public Function DecToHex(ByVal Dec As Long) As String
    
    DecToHex = CStr(Hex(Dec))

End Function
Public Function isPrime(ByVal n As Long) As Boolean
    Dim P As Long

    On Local Error GoTo Quit
    
    If n < 1 Then Exit Function
    
    If n < 4 Then isPrime = True: _
                  Exit Function
                
    If (n / 2) = Int(n / 2) Then Exit Function
    
    For P = 3 To Int(n / 2) Step 2
        If (n / P) = Int(n / P) Then Exit Function
    Next P
    
    isPrime = True

    Exit Function

Quit:
    Call ERROR(MATH, "isPrime", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function BinToDec(ByVal Bin As Long) As Long
    Dim sngNumber As Long, tmp As Long, Output As Long
    Dim x As Integer
    
    sngNumber = Bin

    For x = 0 To Len(CStr(sngNumber)) - 1
        tmp = CLng(Right$(CStr(sngNumber), 1))
    
        If tmp = 1 Then tmp = tmp * Pow(2, x)
        
        Output = Output + tmp
        tmp = 1

        If Len(CStr(sngNumber)) > 1 Then
            sngNumber = CLng(Left$(CStr(sngNumber), Len(CStr(sngNumber)) - 1))
        Else
            sngNumber = 0
        End If
    Next x
    
    BinToDec = Output

End Function
Public Function Fakultaet(ByVal Zahl As Long, _
                          Optional ErrorNumber As Long) As Variant
    Dim L As Long
    Dim nFak As Double
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Zahl = 1 Then
        Fakultaet = 1
        Exit Function
    End If
    
    nFak = 1
            
    For L = 1 To Zahl
        nFak = nFak * CDbl(L)
    Next L
            
    Fakultaet = nFak
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Fakultaet = -2
    
    Call ERROR(MATH, "Fakultaet", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Quersumme(ByVal Zahl As Long) As Long
    
    Do While Zahl
        Quersumme = Quersumme + (Zahl Mod 10)
        Zahl = Zahl \ 10
    Loop

End Function
Public Function Pythag(Optional A As Variant, Optional B As Variant, _
                       Optional Hyp As Variant, Optional ErrorNumber As Long) As Double
    Dim x As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If IsMissing(A) Then x = 1
    If IsMissing(B) Then x = x + 1
    If IsMissing(Hyp) Then x = x + 1
    
    If x < 2 Then
        If IsMissing(Hyp) Then Pythag = Sqr((A ^ 2) + (B ^ 2))
        If IsMissing(A) Then Pythag = Sqr((Hyp ^ 2) - (B ^ 2))
        If IsMissing(B) Then Pythag = Sqr((Hyp ^ 2) - (A ^ 2))
    Else
        Pythag = -1
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Pythag = -2
    
    Call ERROR(MATH, "Pythag", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function LOWORD(ByVal nDWord As Long) As Long
    
    LOWORD = CLng("&H" & Left$(Right$("00000000" & Hex$(nDWord), 8), 4))

End Function
Public Function HiWord(ByVal nDWord As Long) As Long
    
    HiWord = CLng("&H" & Right$(Right$("00000000" & Hex$(nDWord), 8), 4))

End Function
Public Function DWord(ByVal nLow As Integer, ByVal nHigh As Integer) As Long
    Dim sLow As String, sHigh As String
   
    sLow = STRING$(4 - Len(Hex$(nLow)), "0") & Hex$(nLow)
    sHigh = STRING$(4 - Len(Hex$(nHigh)), "0") & Hex$(nHigh)

    DWord = CLng("&H" & sLow & sHigh)

End Function
Public Sub Incr(Var As Long, Optional Value As Long = 1)
    Var = Var + Value
End Sub
Public Sub Decr(Var As Long, Optional Value As Long = 1)
    Var = Var - Value
End Sub
Public Function BYTEINFO(ByVal Bytes As Variant, ByteIs As BYTEISINFO, _
                         Optional ErrorNumber As Long) As BYTEINFOS
    Dim ByteTo As BYTEINFOS
    
    On Local Error GoTo Quit

    ErrorNumber = 0
    
    Select Case ByteIs
        Case biBytes
            'Nope
        Case biGigaBytes
            Bytes = Bytes * 1024
            Bytes = Bytes * 1000
            Bytes = Bytes * 1000
        Case biKiloBytes
            Bytes = Bytes * 1024
        Case biMegaBytes
            Bytes = Bytes * 1024
            Bytes = Bytes * 1000
    End Select
    
    With ByteTo
        .Bytes = Bytes
        .GigaBytes = Round((Bytes / 1048576) / 1024, 2)
        .KiloBytes = Round(Bytes / 1024, 2)
        .MegaBytes = Round(Bytes / 1048576, 2)
    End With
        
    BYTEINFO = ByteTo
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(MATH, "BYTEINFO", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_Num(ByVal sNum As Variant, _
                        ByVal DigitsForDecimal As Long, _
                        ByVal DigitsAfterDecimal As Long, _
                        Optional SeperateNum As Boolean = False, _
                        Optional ErrorNumber As Long) As Variant
    Dim x As Long, Y As Long
    Dim S$, R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    sNum = Replace(sNum, ".", "")
    
    If Not IsNumeric(sNum) Then Exit Function
    
    R$ = CStr(Round(CDbl(sNum), DigitsAfterDecimal))
    
    If SeperateNum Then
        S$ = "###,###." & STRING(DigitsAfterDecimal, "#")
        R$ = Format(R$, S$)
    End If
    
    x = InStr(R$, ",")
    
    If x = 0 Then
        If DigitsAfterDecimal > 0 Then S$ = "," & STRING(DigitsAfterDecimal, "0")
    Else
        Y = DigitsAfterDecimal - (Len(R$) - x)
        
        S$ = mID$(R$, x) & STRING(Y, "0")
        
        If S$ = "," Then
            If DigitsAfterDecimal = 0 Then
                S$ = ""
            Else
                S$ = S$ & STRING(DigitsAfterDecimal, "0")
            End If
        End If
        
        R$ = mID$(R$, 1, x - 1)
    End If
    
    If DigitsForDecimal > 0 Then
        x = DLL.STRING.StringCount(R$, ".")
        Y = Len(R$) - x
        
        If (DigitsForDecimal - Y) > 0 Then R$ = STRING(DigitsForDecimal - Y, "0") & R$
    End If
    
    Get_Num = R$ & S$

    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(MATH, "Get_Num", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function PI() As Double
    PI = (4 * Atn(1))
End Function
Public Function LowestCommonDivisor(ByVal Num As Variant, _
                                    Optional ErrorNumber As Long) As Long
    Dim P As Long, x As Long, Z As Long, S As Long, Y As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Y = Num(LBound(Num))
    S = 0
    
    For P = LBound(Num) To UBound(Num)
        If Num(P) < Y Then Y = Num(P)
        S = S + 1
    Next P
    
    x = 0
    
    For P = LBound(Num) To UBound(Num)
        If Num(P) Mod 2 = 0 Then x = x + 1
    Next P
    
    If x = S Then
        LowestCommonDivisor = 2
        Exit Function
    End If
    
    For P = 3 To Y Step 2
        x = 0
        Z = LBound(Num)
        
        Do While Z <= UBound(Num)
            If Num(Z) Mod P <> 0 Then Exit Do
            
            x = x + 1
            Z = Z + 1
            
            If x = S Then
                LowestCommonDivisor = P
                Exit Function
            End If
        Loop
    Next P

    If LowestCommonDivisor = 0 Then LowestCommonDivisor = -1

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    LowestCommonDivisor = -2
    
    Call ERROR(MATH, "LowestCommonDivisor", Err.Number, Err.Description)
        
    Err.Clear

End Function
