Attribute VB_Name = "basPModule"
Option Explicit

Public Declare Function mixerGetLineInfo& Lib "winmm.dll" Alias "mixerGetLineInfoA" (ByVal hmxobj&, pmxl As MIXERLINE, ByVal fdwInfo&)

Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingA" (ByVal hFile As Long, ByVal lpFileMappigAttributes As Long, ByVal flProtect As Long, ByVal dwMaximumSizeHigh As Long, ByVal dwMaximumSizeLow As Long, ByVal lpName As String) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32" (lpBaseAddress As Any) As Long
Private Declare Function VirtualAllocEx Lib "kernel32" (ByVal hProcess As Long, ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFreeEx Lib "kernel32" (ByVal hProcess As Long, lpAddress As Any, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function mixerGetLineControls& Lib "winmm.dll" Alias "mixerGetLineControlsA" (ByVal hmxobj&, pmxlc As MIXERLINECONTROLS, ByVal fdwControls&)
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Function Netbios Lib "netapi32.dll" (pncb As NCB) As Byte
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long

Private Declare Sub CopyStructFromPtr Lib "kernel32" Alias "RtlMoveMemory" (struct As Any, ByVal ptr&, ByVal cb&)
Private Declare Sub CopyMemory_ByRef Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function GWL Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GWR Lib "user32" Alias "GetWindowRect" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SWL Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwnewLong As Long) As Long
Private Declare Function SWP Lib "user32" Alias "SetWindowPos" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long

Private Const NCBNAMSZ As Byte = 16

Private Type NCB
    ncb_Command    As Byte
    ncb_RetCode    As Byte
    ncb_LSN        As Byte
    ncb_Num        As Byte
    ncb_pBuffer    As Long
    ncb_Length     As Integer
    ncb_CallName   As String * NCBNAMSZ
    ncb_Name       As String * NCBNAMSZ
    ncb_RTO        As Byte
    ncb_STO        As Byte
    ncb_Post       As Long
    ncb_Lana_Num   As Byte
    ncb_Cmd_Cplt   As Byte
    ncb_Reserve(9) As Byte
    ncb_Event      As Long
End Type

Private Type ADAPTER_STATUS
  adapter_address(5) As Byte
  rev_major          As Byte
  reserved0          As Byte
  adapter_type       As Byte
  rev_minor          As Byte
  duration           As Integer
  frmr_recv          As Integer
  frmr_xmit          As Integer
  iframe_recv_err    As Integer
  xmit_aborts        As Integer
  xmit_success       As Long
  recv_success       As Long
  iframe_xmit_err    As Integer
  recv_buff_unavail  As Integer
  t1_timeouts        As Integer
  ti_timeouts        As Integer
  Reserved1          As Long
  free_ncbs          As Integer
  max_cfg_ncbs       As Integer
  max_ncbs           As Integer
  xmit_buf_unavail   As Integer
  max_dgram_size     As Integer
  pending_sess       As Integer
  max_cfg_sess       As Integer
  max_sess           As Integer
  max_sess_pkt_size  As Integer
  name_count         As Integer
End Type

Private Type NAME_BUFFER
  Name       As String * NCBNAMSZ
  name_num   As Integer
  name_flags As Integer
End Type

Private Type ASTAT
  adapt        As ADAPTER_STATUS
  NameBuff(30) As NAME_BUFFER
End Type

Private Type ENUM_LANA
    bCount     As Byte
    bLana(300) As Byte
End Type

Private Type MIXERLINECONTROLS
     cbStruct  As Long
     dwLineID  As Long
     dwControl As Long
     cControls As Long
     cbmxctrl  As Long
     pamxctrl  As Long
End Type

Public Type MIXERCONTROL
     cbStruct       As Long
     dwControlID    As Long
     dwControlType  As Long
     fdwControl     As Long
     cMultipleItems As Long
     szShortName    As String * 16
     szName         As String * 64
     lMinimum       As Long
     lMaximum       As Long
     Reserved(10)   As Long
End Type

Public Type MIXERSETTINGS
     MxrChannels As Long
     MxrLeftVol  As Long
     MxrRightVol As Long
     MxrVol      As Long
     MxrVolID    As Long
     MxrMute     As Long
     MxrMuteID   As Long
     MxrPeakID   As Long
End Type

Public Type Target
     dwType         As Long
     dwDeviceID     As Long
     wMid           As Integer
     wPid           As Integer
     vDriverVersion As Long
     szPname        As String * 32
End Type

Public Type MIXERLINE
     cbStruct As Long
     dwDestination As Long
     dwSource As Long
     dwLineID As Long
     fdwLine As Long
     dwUser As Long
     dwComponentType As Long
     cChannels As Long
     cConnections As Long
     cControls As Long
     szShortName As String * 16
     szName As String * 64
     lpTarget As Target
End Type

Public Type MIXERCONTROLDETAILS
     cbStruct As Long
     dwControlID As Long
     cChannels As Long
     Item As Long
     cbDetails As Long
     paDetails As Long
End Type

Public Type BROWSEINFO
    hWndOwner      As Long
    pidlRoot       As Long
    pszDisplayName As String
    lpszTitle      As String
    ulFlags        As Long
    lpfn           As Long
    lParam         As Long
    iImage         As Long
End Type

Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Public Enum DLLClassType
    Array_ = 1
    Controls = 2
    DataBase = 3
    DESKTOP = 4
    DIALOG = 5
    Directory_ = 6
    Drive_ = 7
    File_ = 8
    Forms_ = 9
    Grafic = 10
    HARDWARE = 11
    LB_CB = 12
    MATH = 13
    Menu = 14
    Misc_ = 15
    mString = 16
    mMedia = 17
    NET = 18
    Office = 19
    Reg = 20
    RTF_ = 21
    SHELL_ = 22
    Sys = 23
    Txt = 24
    WIN = 25
    TT = 26
    INI = 27
    
    basFileBase_ = 101
    basPModule_ = 102
End Enum

Public Enum CISNFO
    cisGETCURSEL = 1
    cisSETCURSEL = 2
    cisINSERTSTRING = 3
    cisDELETESTRING = 4
    cisRESETCONTENT = 5
    cisFINDSTRINGEXACT = 6
    cisFINDSTRING = 7
    
    cisLB_SETSEL = 8
End Enum

Public Enum BROWSEFORCONSTANTS
    bfBROWSEFORPRINTER = BIF_BROWSEFORPRINTER
    bfBROWSEFORCOMPUTER = BIF_BROWSEFORCOMPUTER
    bfBROWSEFORFOLDER = BIF_RETURNONLYFSDIRS
    bfBROWSEFORLOCALFOLDER = BIF_RETURNFSANCESTORS
End Enum

Private Const FILE_ATTRIBUTE_DIRECTORY = &H10

Private Const CB_FINDSTRING = &H14C
Private Const CB_INSERTSTRING = &H14A
Private Const CB_GETCURSEL = &H147

Private Const LB_DELETESTRING = &H182
Private Const LB_FINDSTRING = &H18F
Private Const LB_GETCURSEL = &H188
Private Const LB_SETSEL = &H185

Private Const MEM_RESERVE = &H2000
Private Const MEM_RELEASE = &H8000
Private Const MEM_COMMIT = &H1000

Private Const NRC_GOODRET As Long = &H0

Private Const PAGE_READWRITE = &H4&

Private Const PROCESS_VM_OPERATION = &H8
Private Const PROCESS_VM_WRITE = &H20

Private Const STANDARD_RIGHTS_REQUIRED = &HF0000

Private Const SECTION_QUERY = &H1
Private Const SECTION_MAP_WRITE = &H2
Private Const SECTION_MAP_READ = &H4
Private Const SECTION_MAP_EXECUTE = &H8
Private Const SECTION_EXTEND_SIZE = &H10

Private Const SECTION_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SECTION_QUERY Or SECTION_MAP_WRITE Or SECTION_MAP_READ Or SECTION_MAP_EXECUTE Or SECTION_EXTEND_SIZE

Private Const FILE_MAP_ALL_ACCESS = SECTION_ALL_ACCESS

Public Const CB_RESETCONTENT = &H14B
Public Const LB_RESETCONTENT = &H184

Public LoadProgbar As Boolean
Public PBar As New ProgBar

Dim m_CRC32Asm() As Byte
Dim m_CRC32 As Long
Dim m_CRC32Table(0 To 255) As Long

'GetAllPath
Dim frm As frmTMP

Public hMixer As Long, ML As MIXERLINE
Public dcDesktops() As String, Dirs() As String

Public Function GetBitmapData(pBox As PictureBox) As String
    Dim BitmapHeight As Long
    Dim strBitmapHeight As String, BitmapData As String
    Dim BitmapWidth As Long, BitmapBytes As Long
    Dim BytesPerPixel As Integer
    Dim strBytesPerPixel As String, strBitmapWidth As String
    Dim bmp As BITMAP
    
    GetObject pBox.Image.Handle, Len(bmp), bmp
        
    BitmapHeight = bmp.bmHeight
    BitmapWidth = bmp.bmWidth
    BytesPerPixel = (bmp.bmBitsPixel \ 8)
    BitmapBytes = BitmapHeight * BitmapWidth * BytesPerPixel
    
    BitmapData = Space$(BitmapBytes)
    GetBitmapBits pBox.Image.Handle, BitmapBytes, ByVal BitmapData
    
    strBitmapHeight = Space$(4)
    CopyMemory ByVal strBitmapHeight, BitmapHeight, 4
    
    strBitmapWidth = Space$(4)
    CopyMemory ByVal strBitmapWidth, BitmapWidth, 4
    
    strBytesPerPixel = Space$(2)
    CopyMemory ByVal strBytesPerPixel, BytesPerPixel, 2
    
    GetBitmapData = strBitmapHeight & strBitmapWidth & strBytesPerPixel & BitmapData

End Function
Public Function GetAllFiles(ByVal Root As String, ByVal Such As String, _
                            Optional FindDirectory As Boolean, Optional ShowProgress As Boolean = False) As String
    Dim File As String
    Dim hFile As Long
    Dim R$
    Dim FD As WIN32_FIND_DATA
    
    Static frm As ProgBar

    If ShowProgress And LoadProgbar Then
        Set frm = New ProgBar
        Load frm
        
        LoadProgbar = False
        
        Call frm.SetOption(0, 0, "Searching...", False, vbBlue)
    End If
    
    Root = GetDir(Root)
    
    If ShowProgress Then
        R$ = DLL.CRTL.Control_CompactPath(frm.Message, Root)
        
        frm.Message.Caption = R$
        frm.Message.Refresh
    End If
        
    hFile = FindFirstFile(Root & "*.*", FD)
    If hFile = 0 Then Exit Function
    
    Do
        File = VBA.Left$(FD.cFileName, InStr(FD.cFileName, Chr$(0)) - 1)
              
       If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
            If (File <> ".") And (File <> "..") Then
                If FindDirectory And LCase(File) = LCase(Such) Then
                    GetAllFiles = Root & File
                    
                    Unload frm
                    Set frm = Nothing
                    
                    Exit Function
                Else
                    GetAllFiles = GetAllFiles(Root & File, Such, FindDirectory, ShowProgress)
                End If
            End If
       Else
            If Not FindDirectory And LCase(File) = LCase(Such) Then
                GetAllFiles = Root & File
                
                Unload frm
                Set frm = Nothing
                
                LoadProgbar = True
                
                Exit Function
            End If
        End If
    
    Loop While FindNextFile(hFile, FD) And GetAllFiles = ""
        
    Call FindClose(hFile)
        
End Function
Public Function toHex(ByVal Res As Byte, ByVal Str As String) As String
    Dim AA As String, BB As String, cc As String, ERg As String
    Dim x As Integer
    Dim aVal As Byte
  
    AA = Str
    
    x = Res - Len(AA) Mod Res
    If x <> Res Then AA = AA & Space(x)
    
    For x = 1 To Len(AA)
        BB = mID$(AA, x, 1)
      
        If BB = Chr$(0) Then
            aVal = 0
        Else
            aVal = (Asc(BB))
        End If
      
        ERg = ERg & Hex(aVal)
      
        If x Mod Res <> 0 Then
            ERg = ERg & " "
        Else
            ERg = ERg & " "
            cc = ""
        End If
    Next x
    
    If Right$(ERg, 1) = " " Then ERg = mID$(ERg, 1, Len(ERg) - 1)
    
    toHex = ERg

End Function
Public Function Pow(Number As Long, Power As Integer) As Long
    Dim x As Integer

    If Power > 1 Then
        For x = 2 To Power
            Number = Number * 2
        Next x

        Pow = Number
    Else
        If Power = 0 Then Pow = 1
        If Power = 1 Then Pow = Number
    End If

End Function
Public Function FindSysTray() As Long
    Dim h1 As Long, h2 As Long, h3 As Long
    Dim Wv As OPERATINGSYSTEM
        
    h1 = FindWindowA("Shell_TrayWnd", vbNullString)

    If h1 Then
        h2 = FindWindowEx(h1, 0, "TrayNotifyWnd", vbNullString)
    
        Wv = DLL.SYSTEM.Get_WinVer
    
        If DLL.SYSTEM.isWindowsNT Or Wv = osWindowsMillenium Then
            If Wv = osWindows2003 Or Wv = osWindows2000 Or Wv = osWindowsXP Then
                h2 = FindWindowEx(h2, 0, "SysPager", vbNullString)
        
                If h2 Then
                    h3 = FindWindowEx(h2, 0, "ToolbarWindow32", vbNullString)
                    FindSysTray = h3
                End If
            End If
        Else
            FindSysTray = h2
        End If
    End If

End Function
Public Sub DoTrans(ByVal hwnd As Long, ByVal Rate As Byte)
    Dim WinInfo As Long

    WinInfo = GetWindowLongA(hwnd, GWL_EXSTYLE)
    
    If Rate < 255 Then
        WinInfo = WinInfo Or WS_EX_LAYERED
        SetWindowLong hwnd, GWL_EXSTYLE, WinInfo
        SetLayeredWindowAttributes hwnd, 0, Rate, LWA_ALPHA
    Else
        WinInfo = WinInfo Xor WS_EX_LAYERED
        SetWindowLong hwnd, GWL_EXSTYLE, WinInfo
    End If

End Sub
Private Function CreatePoly(objBild As PictureBox) As Long
    Dim lngTransparenteFarbe As Long, lngStartLinie_X As Long
    Dim bolErsterBereich As Boolean, bolEingangsLinie As Boolean
    Dim hDC As Long, lngBildWeite As Long, lngBildHoehe As Long
    Dim lngX As Long, lngY As Long
    Dim lngGesamtBereich As Long, lngLinienBereich As Long

    
    hDC = objBild.hDC
    
    lngBildWeite = objBild.ScaleWidth
    lngBildHoehe = objBild.ScaleHeight
    
    bolErsterBereich = True
    bolEingangsLinie = False
    
    lngX = lngY = lngStartLinie_X = 0
    
    lngTransparenteFarbe = GetPixel(hDC, 0, 0)

    For lngY = 0 To lngBildHoehe - 1
        For lngX = 0 To lngBildWeite - 1
            If GetPixel(hDC, lngX, lngY) = lngTransparenteFarbe Or _
                                           lngX = lngBildWeite Then
                If bolEingangsLinie Then
                    bolEingangsLinie = False
                    lngLinienBereich = CreateRectRgn(lngStartLinie_X, lngY, lngX, lngY + 1)
    
                    If bolErsterBereich Then
                        lngGesamtBereich = lngLinienBereich
                        bolErsterBereich = False
                    Else
                        CombineRgn lngGesamtBereich, lngGesamtBereich, lngLinienBereich, RGN_OR
                        DeleteObject lngLinienBereich
                    End If
                End If
            Else
                If Not bolEingangsLinie Then
                    bolEingangsLinie = True
                    lngStartLinie_X = lngX
                End If
            End If
        Next lngX
    Next lngY
    
    CreatePoly = lngGesamtBereich

End Function
Public Function CFFP(Form As Form, Picture As Picture, File As String) As Long
    Dim FensterBereich As Long

    On Local Error GoTo Quit

    Load MyControls
    
    If File <> "" Then
        MyControls.PicTMP = LoadPicture(File)
    Else
        MyControls.PicTMP.Picture = Picture
    End If
    
    Form.Picture = MyControls.PicTMP.Picture

    With MyControls.PicTMP
        .ScaleMode = vbPixels
        .AutoRedraw = True
        .AutoSize = True
        .BorderStyle = 0
        .Left = 0
        .Top = 0
        
        Form.Width = .Width
        Form.Height = .Height
  End With
  
    FensterBereich = CreatePoly(MyControls.PicTMP)
    
    If SetWindowRgn(Form.hwnd, FensterBereich, True) Then CFFP = True

    Form.Refresh

Quit:
    CFFP = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(basPModule_, "CFFP", Err.Number, Err.Description)
    
    Unload MyControls
    
    Err.Clear
    
End Function
Public Function BubbleSort(Feld As Variant) As Boolean
    Dim LB As Long, uB As Long, POS As Long, x As Long
    Dim temp As String
    
    On Local Error GoTo Quit
    
    LB = LBound(Feld)
    uB = UBound(Feld)
    
    While uB > LB
        POS = LB
      
        For x = LB To uB - 1
            If Feld(x) > Feld(x + 1) Then _
                temp = Feld(x + 1): _
                Feld(x + 1) = Feld(x): _
                Feld(x) = temp: _
                POS = x
        Next x
      
        uB = POS
    Wend
    
Quit:
    If Err.Number <> 0 Then Call ERROR(basPModule_, "BubbleSort", Err.Number, Err.Description)
    
    BubbleSort = (Err.Number = 0)

    Err.Clear
    
End Function
Public Function LBSortItem(ByRef hLBox As ListBox) As Boolean
    Dim idx As Integer, maxElements As Integer
    Dim tmpLB() As String
    
    If hLBox.Sorted = True Then LBSortItem = False: _
                                Exit Function
    
    ReDim tmpLB(hLBox.ListCount - 1)
    maxElements = hLBox.ListCount
    
    For idx = 0 To hLBox.ListCount - 1
        tmpLB(idx) = hLBox.List(idx)
    Next idx
    
    Call SortArray2(tmpLB(), 0, maxElements - 1)
    
    hLBox.Clear
    
    For idx = 0 To maxElements - 1
        hLBox.AddItem tmpLB(idx), 0
    Next idx
    
End Function
Public Sub SortArray2(ByRef tmpArray() As String, ByVal idxLo As Long, ByVal idxHi As Long)
    Dim tmpString As String, tmpSwap As String
    Dim tmpLow As Long, tmpHi As Long
  
    tmpLow = idxLo
    tmpHi = idxHi
    tmpString = tmpArray((idxLo + idxHi) / 2)
  
    While (tmpLow <= tmpHi)
        While (tmpArray(tmpLow) < tmpString) And (tmpLow < idxHi)
            tmpLow = tmpLow + 1
        Wend
  
        While (tmpString < tmpArray(tmpHi)) And (tmpHi > idxLo)
            tmpHi = tmpHi - 1
        Wend
  
        If (tmpLow <= tmpHi) Then
            tmpSwap = tmpArray(tmpLow)
            tmpArray(tmpLow) = tmpArray(tmpHi)
            tmpArray(tmpHi) = tmpSwap
            tmpLow = tmpLow + 1
            tmpHi = tmpHi - 1
        End If
    Wend
   
    If (idxLo < tmpHi) Then SortArray2 tmpArray(), idxLo, tmpHi
    If (tmpLow < idxHi) Then SortArray2 tmpArray(), tmpLow, idxHi

End Sub
' * SFV Start *
Public Function SFV(ByVal File As Variant) As String
    Dim i As Long, P As Long
    Dim lngChunkSize As Long, lngSize As Long
    Dim lngCRC32 As Long
    Dim bArrayFile() As Byte
    Dim F() As Variant
    Dim strFilePath As String, CalculateFile As String

    Const sASM As String = "5589E557565053518B45088B008B750C8B7D108B4D1431DB8A1E30C3C1E80833049F464975F28B4D088901595B585E5F89EC5DC21000"
    
    On Local Error GoTo Quit
    
    If m_CRC32Table(1) = 0 Then
        m_CRC32Table(0) = &H0:          m_CRC32Table(1) = &H77073096
        m_CRC32Table(2) = &HEE0E612C:   m_CRC32Table(3) = &H990951BA
        m_CRC32Table(4) = &H76DC419:    m_CRC32Table(5) = &H706AF48F
        m_CRC32Table(6) = &HE963A535:   m_CRC32Table(7) = &H9E6495A3
        m_CRC32Table(8) = &HEDB8832:    m_CRC32Table(9) = &H79DCB8A4
        m_CRC32Table(10) = &HE0D5E91E:  m_CRC32Table(11) = &H97D2D988
        m_CRC32Table(12) = &H9B64C2B:   m_CRC32Table(13) = &H7EB17CBD
        m_CRC32Table(14) = &HE7B82D07:  m_CRC32Table(15) = &H90BF1D91
        m_CRC32Table(16) = &H1DB71064:  m_CRC32Table(17) = &H6AB020F2
        m_CRC32Table(18) = &HF3B97148:  m_CRC32Table(19) = &H84BE41DE
        m_CRC32Table(20) = &H1ADAD47D:  m_CRC32Table(21) = &H6DDDE4EB
        m_CRC32Table(22) = &HF4D4B551:  m_CRC32Table(23) = &H83D385C7
        m_CRC32Table(24) = &H136C9856:  m_CRC32Table(25) = &H646BA8C0
        m_CRC32Table(26) = &HFD62F97A:  m_CRC32Table(27) = &H8A65C9EC
        m_CRC32Table(28) = &H14015C4F:  m_CRC32Table(29) = &H63066CD9
        m_CRC32Table(30) = &HFA0F3D63:  m_CRC32Table(31) = &H8D080DF5
        m_CRC32Table(32) = &H3B6E20C8:  m_CRC32Table(33) = &H4C69105E
        m_CRC32Table(34) = &HD56041E4:  m_CRC32Table(35) = &HA2677172
        m_CRC32Table(36) = &H3C03E4D1:  m_CRC32Table(37) = &H4B04D447
        m_CRC32Table(38) = &HD20D85FD:  m_CRC32Table(39) = &HA50AB56B
        m_CRC32Table(40) = &H35B5A8FA:  m_CRC32Table(41) = &H42B2986C
        m_CRC32Table(42) = &HDBBBC9D6:  m_CRC32Table(43) = &HACBCF940
        m_CRC32Table(44) = &H32D86CE3:  m_CRC32Table(45) = &H45DF5C75
        m_CRC32Table(46) = &HDCD60DCF:  m_CRC32Table(47) = &HABD13D59
        m_CRC32Table(48) = &H26D930AC:  m_CRC32Table(49) = &H51DE003A
        m_CRC32Table(50) = &HC8D75180:  m_CRC32Table(51) = &HBFD06116
        m_CRC32Table(52) = &H21B4F4B5:  m_CRC32Table(53) = &H56B3C423
        m_CRC32Table(54) = &HCFBA9599:  m_CRC32Table(55) = &HB8BDA50F
        m_CRC32Table(56) = &H2802B89E:  m_CRC32Table(57) = &H5F058808
        m_CRC32Table(58) = &HC60CD9B2:  m_CRC32Table(59) = &HB10BE924
        m_CRC32Table(60) = &H2F6F7C87:  m_CRC32Table(61) = &H58684C11
        m_CRC32Table(62) = &HC1611DAB:  m_CRC32Table(63) = &HB6662D3D
        m_CRC32Table(64) = &H76DC4190:  m_CRC32Table(65) = &H1DB7106
        m_CRC32Table(66) = &H98D220BC:  m_CRC32Table(67) = &HEFD5102A
        m_CRC32Table(68) = &H71B18589:  m_CRC32Table(69) = &H6B6B51F
        m_CRC32Table(70) = &H9FBFE4A5:  m_CRC32Table(71) = &HE8B8D433
        m_CRC32Table(72) = &H7807C9A2:  m_CRC32Table(73) = &HF00F934
        m_CRC32Table(74) = &H9609A88E:  m_CRC32Table(75) = &HE10E9818
        m_CRC32Table(76) = &H7F6A0DBB:  m_CRC32Table(77) = &H86D3D2D
        m_CRC32Table(78) = &H91646C97:  m_CRC32Table(79) = &HE6635C01
        m_CRC32Table(80) = &H6B6B51F4:  m_CRC32Table(81) = &H1C6C6162
        m_CRC32Table(82) = &H856530D8:  m_CRC32Table(83) = &HF262004E
        m_CRC32Table(84) = &H6C0695ED:  m_CRC32Table(85) = &H1B01A57B
        m_CRC32Table(86) = &H8208F4C1:  m_CRC32Table(87) = &HF50FC457
        m_CRC32Table(88) = &H65B0D9C6:  m_CRC32Table(89) = &H12B7E950
        m_CRC32Table(90) = &H8BBEB8EA:  m_CRC32Table(91) = &HFCB9887C
        m_CRC32Table(92) = &H62DD1DDF:  m_CRC32Table(93) = &H15DA2D49
        m_CRC32Table(94) = &H8CD37CF3:  m_CRC32Table(95) = &HFBD44C65
        m_CRC32Table(96) = &H4DB26158:  m_CRC32Table(97) = &H3AB551CE
        m_CRC32Table(98) = &HA3BC0074:  m_CRC32Table(99) = &HD4BB30E2
        m_CRC32Table(100) = &H4ADFA541: m_CRC32Table(101) = &H3DD895D7
        m_CRC32Table(102) = &HA4D1C46D: m_CRC32Table(103) = &HD3D6F4FB
        m_CRC32Table(104) = &H4369E96A: m_CRC32Table(105) = &H346ED9FC
        m_CRC32Table(106) = &HAD678846: m_CRC32Table(107) = &HDA60B8D0
        m_CRC32Table(108) = &H44042D73: m_CRC32Table(109) = &H33031DE5
        m_CRC32Table(110) = &HAA0A4C5F: m_CRC32Table(111) = &HDD0D7CC9
        m_CRC32Table(112) = &H5005713C: m_CRC32Table(113) = &H270241AA
        m_CRC32Table(114) = &HBE0B1010: m_CRC32Table(115) = &HC90C2086
        m_CRC32Table(116) = &H5768B525: m_CRC32Table(117) = &H206F85B3
        m_CRC32Table(118) = &HB966D409: m_CRC32Table(119) = &HCE61E49F
        m_CRC32Table(120) = &H5EDEF90E: m_CRC32Table(121) = &H29D9C998
        m_CRC32Table(122) = &HB0D09822: m_CRC32Table(123) = &HC7D7A8B4
        m_CRC32Table(124) = &H59B33D17: m_CRC32Table(125) = &H2EB40D81
        m_CRC32Table(126) = &HB7BD5C3B: m_CRC32Table(127) = &HC0BA6CAD
        m_CRC32Table(128) = &HEDB88320: m_CRC32Table(129) = &H9ABFB3B6
        m_CRC32Table(130) = &H3B6E20C:  m_CRC32Table(131) = &H74B1D29A
        m_CRC32Table(132) = &HEAD54739: m_CRC32Table(133) = &H9DD277AF
        m_CRC32Table(134) = &H4DB2615:  m_CRC32Table(135) = &H73DC1683
        m_CRC32Table(136) = &HE3630B12: m_CRC32Table(137) = &H94643B84
        m_CRC32Table(138) = &HD6D6A3E:  m_CRC32Table(139) = &H7A6A5AA8
        m_CRC32Table(140) = &HE40ECF0B: m_CRC32Table(141) = &H9309FF9D
        m_CRC32Table(142) = &HA00AE27:  m_CRC32Table(143) = &H7D079EB1
        m_CRC32Table(144) = &HF00F9344: m_CRC32Table(145) = &H8708A3D2
        m_CRC32Table(146) = &H1E01F268: m_CRC32Table(147) = &H6906C2FE
        m_CRC32Table(148) = &HF762575D: m_CRC32Table(149) = &H806567CB
        m_CRC32Table(150) = &H196C3671: m_CRC32Table(151) = &H6E6B06E7
        m_CRC32Table(152) = &HFED41B76: m_CRC32Table(153) = &H89D32BE0
        m_CRC32Table(154) = &H10DA7A5A: m_CRC32Table(155) = &H67DD4ACC
        m_CRC32Table(156) = &HF9B9DF6F: m_CRC32Table(157) = &H8EBEEFF9
        m_CRC32Table(158) = &H17B7BE43: m_CRC32Table(159) = &H60B08ED5
        m_CRC32Table(160) = &HD6D6A3E8: m_CRC32Table(161) = &HA1D1937E
        m_CRC32Table(162) = &H38D8C2C4: m_CRC32Table(163) = &H4FDFF252
        m_CRC32Table(164) = &HD1BB67F1: m_CRC32Table(165) = &HA6BC5767
        m_CRC32Table(166) = &H3FB506DD: m_CRC32Table(167) = &H48B2364B
        m_CRC32Table(168) = &HD80D2BDA: m_CRC32Table(169) = &HAF0A1B4C
        m_CRC32Table(170) = &H36034AF6: m_CRC32Table(171) = &H41047A60
        m_CRC32Table(172) = &HDF60EFC3: m_CRC32Table(173) = &HA867DF55
        m_CRC32Table(174) = &H316E8EEF: m_CRC32Table(175) = &H4669BE79
        m_CRC32Table(176) = &HCB61B38C: m_CRC32Table(177) = &HBC66831A
        m_CRC32Table(178) = &H256FD2A0: m_CRC32Table(179) = &H5268E236
        m_CRC32Table(180) = &HCC0C7795: m_CRC32Table(181) = &HBB0B4703
        m_CRC32Table(182) = &H220216B9: m_CRC32Table(183) = &H5505262F
        m_CRC32Table(184) = &HC5BA3BBE: m_CRC32Table(185) = &HB2BD0B28
        m_CRC32Table(186) = &H2BB45A92: m_CRC32Table(187) = &H5CB36A04
        m_CRC32Table(188) = &HC2D7FFA7: m_CRC32Table(189) = &HB5D0CF31
        m_CRC32Table(190) = &H2CD99E8B: m_CRC32Table(191) = &H5BDEAE1D
        m_CRC32Table(192) = &H9B64C2B0: m_CRC32Table(193) = &HEC63F226
        m_CRC32Table(194) = &H756AA39C: m_CRC32Table(195) = &H26D930A
        m_CRC32Table(196) = &H9C0906A9: m_CRC32Table(197) = &HEB0E363F
        m_CRC32Table(198) = &H72076785: m_CRC32Table(199) = &H5005713
        m_CRC32Table(200) = &H95BF4A82: m_CRC32Table(201) = &HE2B87A14
        m_CRC32Table(202) = &H7BB12BAE: m_CRC32Table(203) = &HCB61B38
        m_CRC32Table(204) = &H92D28E9B: m_CRC32Table(205) = &HE5D5BE0D
        m_CRC32Table(206) = &H7CDCEFB7: m_CRC32Table(207) = &HBDBDF21
        m_CRC32Table(208) = &H86D3D2D4: m_CRC32Table(209) = &HF1D4E242
        m_CRC32Table(210) = &H68DDB3F8: m_CRC32Table(211) = &H1FDA836E
        m_CRC32Table(212) = &H81BE16CD: m_CRC32Table(213) = &HF6B9265B
        m_CRC32Table(214) = &H6FB077E1: m_CRC32Table(215) = &H18B74777
        m_CRC32Table(216) = &H88085AE6: m_CRC32Table(217) = &HFF0F6A70
        m_CRC32Table(218) = &H66063BCA: m_CRC32Table(219) = &H11010B5C
        m_CRC32Table(220) = &H8F659EFF: m_CRC32Table(221) = &HF862AE69
        m_CRC32Table(222) = &H616BFFD3: m_CRC32Table(223) = &H166CCF45
        m_CRC32Table(224) = &HA00AE278: m_CRC32Table(225) = &HD70DD2EE
        m_CRC32Table(226) = &H4E048354: m_CRC32Table(227) = &H3903B3C2
        m_CRC32Table(228) = &HA7672661: m_CRC32Table(229) = &HD06016F7
        m_CRC32Table(230) = &H4969474D: m_CRC32Table(231) = &H3E6E77DB
        m_CRC32Table(232) = &HAED16A4A: m_CRC32Table(233) = &HD9D65ADC
        m_CRC32Table(234) = &H40DF0B66: m_CRC32Table(235) = &H37D83BF0
        m_CRC32Table(236) = &HA9BCAE53: m_CRC32Table(237) = &HDEBB9EC5
        m_CRC32Table(238) = &H47B2CF7F: m_CRC32Table(239) = &H30B5FFE9
        m_CRC32Table(240) = &HBDBDF21C: m_CRC32Table(241) = &HCABAC28A
        m_CRC32Table(242) = &H53B39330: m_CRC32Table(243) = &H24B4A3A6
        m_CRC32Table(244) = &HBAD03605: m_CRC32Table(245) = &HCDD70693
        m_CRC32Table(246) = &H54DE5729: m_CRC32Table(247) = &H23D967BF
        m_CRC32Table(248) = &HB3667A2E: m_CRC32Table(249) = &HC4614AB8
        m_CRC32Table(250) = &H5D681B02: m_CRC32Table(251) = &H2A6F2B94
        m_CRC32Table(252) = &HB40BBE37: m_CRC32Table(253) = &HC30C8EA1
        m_CRC32Table(254) = &H5A05DF1B: m_CRC32Table(255) = &H2D02EF8D
    End If
    
    ReDim m_CRC32Asm(0 To Len(sASM) \ 2 - 1)
        
    For i = 1 To Len(sASM) Step 2
        m_CRC32Asm(i \ 2) = Val("&H" & mID$(sASM, i, 2))
    Next i
        
    m_CRC32 = &HFFFFFFFF

    If Not DLL.ARRAY.isArray(File) Then
        ReDim F(0)
        F(0) = File
    Else
        F = File
    End If
    
    For P = 0 To UBound(F)
        strFilePath = F(P)
        lngSize = FileLen(strFilePath)
        lngChunkSize = 4096

        If lngSize <> 0 Then
            Open strFilePath For Binary Access Read As #1
                Do While Seek(1) < lngSize
                    If (lngSize - Seek(1)) > lngChunkSize Then
                        Do While Seek(1) < (lngSize - lngChunkSize)
                            ReDim bArrayFile(lngChunkSize - 1)
                            
                            Get #1, , bArrayFile()
                            
                            lngCRC32 = CalculateBytes(bArrayFile)
                            
                            DoEvents
                        Loop
                    Else
                        ReDim bArrayFile(lngSize - Seek(1))
                        
                        Get #1, , bArrayFile()
            
                        lngCRC32 = CalculateBytes(bArrayFile)
                    End If
                    
                    DoEvents
                Loop
            Close #1
    
            CalculateFile = Right$("00000000" & Hex$(lngCRC32), 8)
        Else
            CalculateFile = "00000000"
        End If
    Next P
    
    SFV = CalculateFile
    
Quit:
    If Err.Number <> 0 Then
        SFV = "ERROR " & Err.Number & " (" & Err.Description & ")"
    
        If Err.Number <> 0 Then Call ERROR(basPModule_, "SFV", Err.Number, Err.Description)
    End If
    
End Function
Private Function CalculateBytes(ByteArray() As Byte) As Variant
    CalculateBytes = AddBytes(ByteArray)
End Function
Private Function AddBytes(ByteArray() As Byte) As Variant
    Dim ByteSize As Long
  
    On Local Error GoTo NoData
  
    ByteSize = UBound(ByteArray) - LBound(ByteArray) + 1
  
    On Local Error GoTo 0
  
    Call CallWindowProc(VarPtr(m_CRC32Asm(0)), VarPtr(m_CRC32), VarPtr(ByteArray(LBound(ByteArray))), VarPtr(m_CRC32Table(0)), ByteSize)
  
NoData:
    AddBytes = (Not m_CRC32)
  
' * SFV End *
End Function
Public Sub UpdateWin(hwnd As Long)
    Dim R As RECT
    
    Call GetWindowRect(hwnd, R)
    Call SetWindowPos(hwnd, 0, R.Left, R.Top, _
                      R.Right - R.Left, R.Bottom - R.Top, SWP_FRAMECHANGED)

End Sub
Public Function GetAllPath(ByVal Root As String, _
                           ByVal InclSub As Boolean, _
                           FileCount As Long, DirCount As Long, _
                           Optional ShowProgress As Boolean = False) As Variant
    Dim File As String, R$
    Dim hFile As Long
    Dim FD As WIN32_FIND_DATA
    
    Static Count As Long, FC As Long, DC As Long
    Static S As Variant
    
    On Local Error Resume Next
        
    If Count = 0 Then
        S = 0: FC = 0: DC = 0
        
        If ShowProgress Then
            Set frm = New frmTMP
        
            Load frm
        
            frm.lblDir.Caption = ".."
        
            frm.frameDir.Visible = True
            
            frm.frameDir.Top = 0
            frm.frameDir.Left = 120
        
            frm.Width = 8070
            frm.Height = 800
        
            Call DLL.FORMS.Center(frm, ccMIDDLE)
            Call DLL.FORMS.StayOnTop(frm)
        
            frm.Visible = True
            frm.Refresh
        End If
    End If
        
    Count = Count + 1
    
    If VBA.Right$(Root, 1) <> "\" Then Root = Root & "\"
    
    hFile = FindFirstFile(Root & "*.*", FD)
    
    If hFile = 0 Then
        If ShowProgress Then Unload frm: _
                             Set frm = Nothing
        
        Exit Function
    End If
    
    Do
        File = VBA.Left$(FD.cFileName, InStr(FD.cFileName, Chr$(0)) - 1)
        
        If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
            If File <> "." And File <> ".." Then
                DC = DC + 1
                 
                If ShowProgress Then R$ = DLL.CRTL.Control_CompactPath(frm.lblDir, Root & File): _
                                     frm.lblDir.Caption = R$: _
                                     frm.lblDir.Refresh: _
                                     DoEvents
                
                If InclSub Then Call GetAllPath(Root & File, True, FileCount, DirCount, ShowProgress)
            End If
        Else
            FC = FC + 1
            S = S + CLng(FileLen(Root & File))
        End If
    
    Loop While FindNextFile(hFile, FD)
        
    Call FindClose(hFile)
        
    Count = Count - 1
    
    If Count = 0 Then
        Unload frm
        Set frm = Nothing
        
        GetAllPath = S
        FileCount = FC
        DirCount = DC
    End If
    
    Err.Clear
    
End Function
Public Function Net_Get_OnlineIPFunc(ByVal Count As Long) As String
    Dim URL As String, strLeft As String, strRight As String
    Dim strWebsource As String, strRes As String
    Dim lngLeft As Long, lngRight As Long
    
    On Local Error GoTo Quit

    Select Case Count
        Case 1: URL = "Http://www.wasistmeineip.de/"
                strLeft = "CopyToClipboard('"
                strRight = "');"
        Case 2: URL = "Http://www.showmyip.de/"
                strLeft = "<br>REMOTE HOST: "
                strRight = vbLf & "<br>PRO"
        Case 3: URL = "ttp://www.whatismyip.com/"
                strLeft = "<h1>Your IP is "
                strRight = " <br></h1>"
    End Select

    strWebsource = DLL.NET.Get_HTMLfile(URL)
    
    If strWebsource = "" Then
        Net_Get_OnlineIPFunc = ""
        Exit Function
    End If

    If LenB(strWebsource) > 0 Then
        lngLeft = InStr(1, strWebsource, strLeft)
        lngRight = InStr(1, strWebsource, strRight)
        
        If (lngLeft > 0) And (lngRight > 0) Then
            strWebsource = mID$(strWebsource, lngLeft + Len(strLeft))
            lngRight = InStr(1, strWebsource, strRight)
            strWebsource = Left$(strWebsource, lngRight - 1)
            strRes = Trim$(strWebsource)
        Else
            Net_Get_OnlineIPFunc = ""
            Exit Function
        End If
    End If

    Net_Get_OnlineIPFunc = strRes

Quit:
    If Err.Number <> 0 Then Call ERROR(basPModule_, "Net_Get_OnlineIPFunc", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Cis(LBCB As Variant, APIcmd As CISNFO, Optional hwnd As Long) As Long
    Dim A As Boolean, B As Boolean
    Dim Class As Boolean
    
    If TypeOf LBCB Is ListBox Then
        A = True
        hwnd = LBCB.hwnd
    Else
        If TypeOf LBCB Is ComboBox Then
            B = True
            hwnd = LBCB.hwnd
        Else
            On Local Error GoTo Quit
        
            hwnd = LBCB
            Class = LCase$(DLL.WINDOW.Get_Class(hwnd))
            
            If InStr(Class, "list") Then A = True
            If (InStr(Class, "combo")) Then B = True
        End If
    End If
            
    If A Then
        Select Case APIcmd
            Case cisDELETESTRING:    Cis = LB_DELETESTRING
            Case cisFINDSTRING:      Cis = LB_FINDSTRING
            Case cisFINDSTRINGEXACT: Cis = LB_FINDSTRINGEXACT
            Case cisGETCURSEL:       Cis = LB_GETCURSEL
            Case cisINSERTSTRING:    Cis = LB_INSERTSTRING
            Case cisLB_SETSEL:       Cis = LB_SETSEL
            Case cisRESETCONTENT:    Cis = LB_RESETCONTENT
            Case cisSETCURSEL:       Cis = LB_SETCURSEL
        End Select
        
        Exit Function
    End If
    
    If B Then
        Select Case APIcmd
            Case cisDELETESTRING:    Cis = CB_DELETESTRING
            Case cisFINDSTRING:      Cis = CB_FINDSTRING
            Case cisFINDSTRINGEXACT: Cis = CB_FINDSTRINGEXACT
            Case cisGETCURSEL:       Cis = CB_GETCURSEL
            Case cisINSERTSTRING:    Cis = CB_INSERTSTRING
            Case cisRESETCONTENT:    Cis = CB_RESETCONTENT
            Case cisSETCURSEL:       Cis = CB_SETCURSEL
        End Select
        
        Exit Function
    End If
    
Quit:
    Cis = -2
    
    Err.Clear
    
End Function
Public Function GetHwnd(Crt As Variant) As Long
    
    On Local Error Resume Next
    
    GetHwnd = Crt.hwnd
    
    If Err.Number <> 0 Then
        GetHwnd = Crt
        Err.Clear
    End If
    
End Function
Public Function ProcessFind(PI() As PROCESSINFO, Optional EXE As String, Optional pid As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
        
    If EXE <> "" Then
        EXE = LCase$(EXE)
        
        For P = 0 To UBound(PI)
            If LCase$(PI(P).EXENAME) = EXE Then ProcessFind = P: _
                                                Exit Function
        Next P
    Else
        For P = 0 To UBound(PI)
            If PI(P).PROCESSID = pid Then ProcessFind = P: _
                                          Exit Function
        Next P
    End If
        
Quit:
    ProcessFind = -1

    If Err.Number <> 0 Then Call ERROR(basPModule_, "ProcessFind", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function GetSysLVHwnd() As Long
    Dim H As Long
  
    H = FindWindowA("Progman", vbNullString)
    
    H = FindWindowEx(H, 0, "SHELLDLL_defVIEW", vbNullString)
  
    GetSysLVHwnd = FindWindowEx(H, 0, "SysListView32", vbNullString)

End Function
Public Function GetMemShared95(ByVal memSize As Long, hFile As Long) As Long
    hFile = CreateFileMapping(&HFFFFFFFF, 0, PAGE_READWRITE, 0, memSize, vbNullString)
    GetMemShared95 = MapViewOfFile(hFile, FILE_MAP_ALL_ACCESS, 0, 0, 0)
End Function
Public Sub FreeMemShared95(ByVal hFile As Long, ByVal lpMem As Long)
    UnmapViewOfFile lpMem
    CloseHandle hFile
End Sub
Public Function GetMemSharedNT(ByVal pid As Long, ByVal memSize As Long, hProcess As Long) As Long
    hProcess = OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ Or PROCESS_VM_WRITE, False, pid)
    GetMemSharedNT = VirtualAllocEx(ByVal hProcess, ByVal 0&, ByVal memSize, MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
End Function
Public Sub FreeMemSharedNT(ByVal hProcess As Long, ByVal MemAddress As Long, ByVal memSize As Long)
    Call VirtualFreeEx(hProcess, ByVal MemAddress, memSize, MEM_RELEASE)
    CloseHandle hProcess
End Sub
Public Sub Taskbar_AddForm(Control As Object, ByVal intWidth As Long, intHeight As Long)
    Dim rectTray As RECT, rectTrayClient As RECT, rectRebar As RECT, rectNotify As RECT
    Dim rectLastTray As RECT, rectLastRebar As RECT, rectLastNotify As RECT
    Dim x As Long, TH As Long, Y As Long, w As Long, H As Long
    
    On Error Resume Next
    
    TH = DLL.DESKTOP.DesktopHWND(dtTASKBAR)
    
    Call GetWindowRect(TH, rectTray)
    Call GetClientRect(TH, rectTrayClient)
    Call GetWindowRect(GetRebarHandle, rectRebar)
    Call GetWindowRect(GetNotifyHandle, rectNotify)
    
    If rectTray.Top <> rectLastTray.Top Or rectRebar.Right <> rectLastRebar.Right Or rectNotify.Left <> rectLastNotify.Left Then
        If (rectTray.Right - rectTray.Left) > (rectTray.Bottom - rectTray.Top) Then
            x = rectRebar.Left - rectTray.Left
            Y = rectTrayClient.Top
            w = rectNotify.Left - rectRebar.Left - intWidth
            H = rectRebar.Bottom - rectRebar.Top
            
            Call MoveWindow(GetRebarHandle, x, Y, w, H, 1)
            Call GetWindowRect(GetRebarHandle, rectRebar)
            
            x = rectRebar.Right
            Y = rectTrayClient.Top + 4
            w = intWidth
            
            If (intHeight > (rectTrayClient.Bottom - rectTrayClient.Top - 6)) Then
                H = rectTrayClient.Bottom - rectTrayClient.Top - 6
            Else
                H = intHeight
            End If
            
            Call MoveWindow(Control.hwnd, x, Y, w, H, 1)
        Else
            If (rectTray.Bottom - rectTray.Top) > (rectTray.Right - rectTray.Left) Then
                x = rectTrayClient.Left
                Y = rectRebar.Top - rectTray.Top
                H = rectNotify.Top - rectRebar.Top - intHeight
                w = rectRebar.Right - rectRebar.Left
                
                Call MoveWindow(GetRebarHandle, x, Y, w, H, 1)
                Call GetWindowRect(GetRebarHandle, rectRebar)
            
                x = rectTrayClient.Left + 4
                Y = rectRebar.Bottom
                H = intHeight
                
                If (intWidth > (rectTrayClient.Right - rectTrayClient.Left - 6)) Then
                    w = rectTrayClient.Right - rectTrayClient.Left - 6
                Else
                    w = intWidth
                End If
            
                Call MoveWindow(Control.hwnd, x, Y, w, H, 1)
            End If
        End If
                
        '   Stay on Top ???
    End If
    
    rectLastTray = rectTray
    rectLastRebar = rectRebar
    rectLastNotify = rectNotify

End Sub
Public Function GetRebarHandle() As Long
    Dim hWnd_Tray As Long, hWnd_Rebar As Long
    
    hWnd_Tray = FindWindowA("Shell_TrayWnd", vbNullString)
    
    If hWnd_Tray <> 0 Then
        hWnd_Rebar = FindWindowEx(hWnd_Tray&, 0, "ReBarWindow32", vbNullString)
    End If
    
    GetRebarHandle = hWnd_Rebar
    
End Function
Function GetNotifyHandle() As Long
    Dim hWnd_Tray As Long, hWnd_Notify As Long
    
    hWnd_Tray = FindWindowA("Shell_TrayWnd", vbNullString)
    
    If hWnd_Tray <> 0 Then
        hWnd_Notify = FindWindowEx(hWnd_Tray&, 0, "TrayNotifyWnd", vbNullString)
    End If
    
    GetNotifyHandle = hWnd_Notify
    
End Function
Public Sub ERROR(DLLclass As DLLClassType, ByVal Routine As String, _
                 ByVal ErrorNumber As Long, ByVal sErrorText As String, _
                 Optional UserMessage As String)
    Dim D$, R$, S$, A$, T() As String, printTxt As String, Msg As String, Class As String
    Dim L As Long, FN As Long, P As Long
    Dim Dat As Date
    
    Static NoStart As Boolean
    
    If Not DebugDebugModus And DebugLogFilePath = "" Then Exit Sub

    D$ = DATE & " / " & TIME & " -> "
    L = Len(D$)
    S$ = STRING(L, " ")
    
    Select Case DLLclass
        Case Is < 100: A$ = "Class: "
        Case Is > 100: A$ = "Modul: "
    End Select
    
    Class = GetMyClass(DLLclass)
    
    R$ = D$ & "DLL ERROR <" & ErrorNumber & ">" & vbCrLf & S$ & A$ & Class & vbCrLf & S$ & "Routine: " & Routine & vbCrLf
    Msg = A$ & Class & " / " & "Routine: " & Routine & vbCrLf & vbCrLf & "Error Description" & vbCrLf & sErrorText
    printTxt = D$ & "DLL ERROR <" & ErrorNumber & ">" & vbCrLf & S$ & A$ & Class & " / " & "Routine: " & Routine & vbCrLf & S$ & sErrorText
      
    If sErrorText <> "" Then
        T = DLL.STRING.sSplit(sErrorText, 39)
        A$ = T(0) & vbCrLf
        
        If UBound(T) > 0 Then
            For P = 1 To UBound(T)
                A$ = A$ & S$ & T(P) & vbCrLf
            Next P
        End If
        
        A$ = mID(A$, 1, Len(A$) - 2)
    Else
        A$ = "<No ErrorText sumbited>"
        printTxt = A$
    End If
    
    sErrorText = A$
    
    If sErrorText <> "" Then R$ = R$ & S$ & sErrorText & vbCrLf
    
    If UserMessage <> "" Then
        R$ = R$ & S$ & UserMessage & vbCrLf & vbCrLf
        printTxt = printTxt & vbCrLf & S$ & UserMessage
    End If

    If Right$(R$, 2) = vbCrLf Then R$ = mID(R$, 1, Len(R$) - 2)

    If DebugDebugModus And (DebugShowMSGonly = False) Then
        frmDebug.Show
        
        If DebugLogFilePath <> "" Then
            frmDebug.txtPath.TEXT = DebugLogFilePath
            frmDebug.butLogFile.Enabled = True
        Else
            frmDebug.txtPath.TEXT = "<No LogFile Selected>"
            frmDebug.butLogFile.Enabled = False
        End If
        
        S$ = frmDebug.txtDebug.TEXT
        S$ = S$ & R$
        
        frmDebug.txtDebug.TEXT = S$
        frmDebug.txtDebug.SelStart = Len(frmDebug.txtDebug.TEXT)
        
        frmDebug.txtDebug.Refresh
        DoEvents
    End If
    
    If DebugShowMSG Then
        Beep
        Call DLL.DIALOG.MsgBox(0, "      DLL Error <" & ErrorNumber & ">", Msg, vbCritical + vbOKOnly, , , 10)
    End If
    
    On Local Error Resume Next
    
    If DebugLogFilePath <> "" Then
        If Not NoStart Then
            NoStart = True
            Dat = Format(DATE, "dd.mm.yyyy")
            
            printTxt = vbCrLf & _
                       STRING(64, "-") & vbCrLf & _
                       "<<<<< " & CStr(Dat) & "/" & TIME & " DLL-ErrorLog startet [v" & DLL.MISC.Verison & "] >>>>>" & vbCrLf & _
                       STRING(64, "-") & vbCrLf & _
                       printTxt & vbCrLf
        End If
        
        FN = FreeFile
    
        Open DebugLogFilePath For Append As FN
            Print #FN, printTxt
        Close FN
    End If
    
    Err.Clear
    
End Sub
Public Function GetMyClass(DLLclass As DLLClassType) As String
    Dim S() As String, T$
    
    Const R$ = "Array,Controls,DataBase,Desktop,Dialog,Directory,Drive,File,Forms,Grafic," & _
               "Hardware,LB_CB,Mathematics,Menu,Misc,mString,Multimedia,Network,Office,Registry," & _
               "RTF,Shell,System,Text,Window,clsTooltip,Ini"
    
    Const U$ = "basFileBase,basPModule"
    
    Select Case DLLclass
        Case Is < 100: S = Split(R$, ",")
                       T$ = S(DLLclass - 1)
        
        Case Is > 100: DLLclass = (DLLclass - 100)
                       S = Split(U$, ",")
                       T$ = S(DLLclass - 1)
    End Select
    
    GetMyClass = T$
    
End Function
Public Function ChangeWindowStyle(ByVal hwnd As Long, ByVal nIndex As Long, STYLE As Long, ByVal Enabled As Boolean)
    Dim lngStyle As Long
    Dim R As RECT
      
    lngStyle = GWL(hwnd, nIndex)

    If (Not Enabled) Then
        lngStyle = lngStyle - STYLE
    Else
        lngStyle = lngStyle Or STYLE
    End If
    
    Call GWR(hwnd, R)
    Call SWL(hwnd, nIndex, lngStyle)
    Call SWP(hwnd, 0, R.Left, R.Top, R.Right - R.Left, R.Bottom - R.Top, SWP_FRAMECHANGED)
    
End Function
Private Function SHA1CircShiftLeftLong(L As Long, n As Integer) As Long
    Dim Z As Long

    SHA1CircShiftLeftLong = L
    
    For Z = 1 To n
        SHA1CircShiftLeftLong = SHA1CircShiftLeftLongLoop(SHA1CircShiftLeftLong)
    Next Z

End Function
Private Function SHA1CircShiftLeftLongLoop(L As Long) As Long
    Dim DB As Double, DB2 As Double

    DB = L
    If DB < 0 Then DB = DB + 4294967296#

    If (DB > 2147483647) Then DB2 = 1 Else DB2 = 0
    DB = DB * 2 + DB2

    Do While (DB > 2147483647#)
        DB = DB - 4294967296#
    Loop
    
    SHA1CircShiftLeftLongLoop = CLng(DB)

End Function
Private Function SHA1F(Z As Long, B As Long, C As Long, D As Long) As Double

    Select Case Z
        Case Is <= 19
            SHA1F = (B And C) Or ((Not B) And D)
        Case Is <= 39
            SHA1F = B Xor C Xor D
        Case Is <= 59
            SHA1F = (B And C) Or (B And D) Or (C And D)
        Case Else
            SHA1F = B Xor C Xor D
    End Select

End Function
Private Function SHA1DB_2_Lng(ByVal DB As Double) As Long

    Do While (DB > 2147483648#): DB = DB - 4294967296#: Loop
    Do While (DB < -2147483647#): DB = DB + 4294967296#: Loop

    SHA1DB_2_Lng = CLng(DB)

End Function
Private Function SHA1Long_2_Hex(L As Long) As String
    SHA1Long_2_Hex = Right("00000000" & Hex(L), 8)
End Function
Public Function SHA1_Bytes(ByRef b_IN() As Byte) As String
    Dim l_W(0 To 79) As Long, Z As Long, Y As Long, l_T As Long
    Dim l_K(3) As Long, l_H(4) As Long, l_A(4) As Long
    Dim b_B() As Byte

    ReDim b_B(UBound(b_IN) + 1 + ((128 - ((UBound(b_IN) + 1) Mod 64) - 9) Mod 64) + 4 + 4)
    
    CopyMemory b_B(0), b_IN(0), UBound(b_IN) + 1
    
    b_B(UBound(b_IN) + 1) = 128
    Z = (UBound(b_IN) + 1) * 8
    
    CopyMemory b_B(UBound(b_B) - 3), Z, 4
    
    Z = b_B(UBound(b_B) - 3)
    b_B(UBound(b_B) - 3) = b_B(UBound(b_B) - 0)
    b_B(UBound(b_B) - 0) = Z
    Z = b_B(UBound(b_B) - 2)
    b_B(UBound(b_B) - 2) = b_B(UBound(b_B) - 1)
    b_B(UBound(b_B) - 1) = Z

    l_K(0) = "&H5A827999"
    l_K(1) = "&H6ED9EBA1"
    l_K(2) = "&H8F1BBCDC"
    l_K(3) = "&HCA62C1D6"
    l_H(0) = "&H67452301"
    l_H(1) = "&HEFCDAB89"
    l_H(2) = "&H98BADCFE"
    l_H(3) = "&H10325476"
    l_H(4) = "&HC3D2E1F0"

    For Z = 0 To ((UBound(b_B) + 1) / 64) - 1
        For Y = 0 To 15
            l_T = (Z * 64) + (Y * 4)
            l_W(Y) = SHA1Bytes_2_Long(b_B(l_T), b_B(l_T + 1), b_B(l_T + 2), b_B(l_T + 3))
        Next Y

        For Y = 16 To 79
            l_W(Y) = SHA1CircShiftLeftLongLoop(l_W(Y - 3) Xor l_W(Y - 8) Xor l_W(Y - 14) Xor l_W(Y - 16))
        Next Y

        For Y = 0 To 4
            l_A(Y) = l_H(Y)
        Next Y

        For Y = 0 To 79
            l_T = SHA1DB_2_Lng(CDbl(SHA1CircShiftLeftLong(l_A(0), 5)) + SHA1F(Y, l_A(1), l_A(2), l_A(3)) + CDbl(l_A(4)) + CDbl(l_W(Y)) + CDbl(l_K(Y \ 20)))
            l_A(4) = l_A(3): l_A(3) = l_A(2)
            l_A(2) = SHA1CircShiftLeftLong(l_A(1), 30)
            l_A(1) = l_A(0): l_A(0) = l_T
        Next Y

        For Y = 0 To 4
            l_H(Y) = SHA1DB_2_Lng(CDbl(l_H(Y)) + CDbl(l_A(Y)))
        Next Y
    Next Z

    SHA1_Bytes = SHA1Long_2_Hex(l_H(0)) & SHA1Long_2_Hex(l_H(1)) & SHA1Long_2_Hex(l_H(2)) & SHA1Long_2_Hex(l_H(3)) & SHA1Long_2_Hex(l_H(4))

End Function
Private Function SHA1Bytes_2_Long(BA As Byte, BB As Byte, BC As Byte, BD As Byte) As Long
    SHA1Bytes_2_Long = "&H" & Right("0" & Hex(BA), 2) & Right("0" & Hex(BB), 2) & Right("0" & Hex(BC), 2) & Right("0" & Hex(BD), 2)
End Function
Public Function GetControlID&(ByVal ComponentType&, ByVal ControlType&)
   Dim hMem&
   Dim MC As MIXERCONTROL
   Dim MxrLine As MIXERLINE
   Dim MLC As MIXERLINECONTROLS

    Const MIXER_GETLINEINFOF_COMPONENTTYPE = &H3&
    Const MIXER_GETLINECONTROLSF_ONEBYTYPE = &H2&

    MxrLine.cbStruct = Len(MxrLine)
    MxrLine.dwComponentType = ComponentType
    
    If mixerGetLineInfo(hMixer, MxrLine, MIXER_GETLINEINFOF_COMPONENTTYPE) = 0 Then
        MLC.cbStruct = Len(MLC)
        MLC.dwLineID = ML.dwLineID
        MLC.dwControl = ControlType
        MLC.cControls = 1
        MLC.cbmxctrl = Len(MC)

        hMem = GlobalAlloc(&H40, Len(MC))
        MLC.pamxctrl = GlobalLock(hMem)
        MC.cbStruct = Len(MC)

        If mixerGetLineControls(hMixer, MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE) = 0 Then
            CopyStructFromPtr MC, MLC.pamxctrl, Len(MC)
            GetControlID = MC.dwControlID
        End If

        GlobalUnlock hMem
        GlobalFree hMem
    End If

End Function
Public Function EnumDesktopProc(ByVal lpszDesktop As Long) As Boolean
    Dim Buffer As String
    Dim x As Long, Y As Long
    
    Buffer = Space(lstrlen(lpszDesktop))
    CopyMemory Buffer, lpszDesktop, Len(Buffer)
    
    On Local Error Resume Next
    
    x = UBound(dcDesktops)
    
    If Err.Number <> 0 Then
        Err.Clear
        x = 0
    Else
        x = x + 1
    End If
    
    ReDim Preserve dcDesktops(x)
    
    Y = InStr(Buffer, Chr$(0))
    If Y > 0 Then Buffer = mID(Buffer, 1, Y - 1)
    
    dcDesktops(x) = Buffer
    
    EnumDesktopProc = True

End Function
Public Sub Wait(ByVal WaitTime As Long)
    Dim P As Long
    
    For P = 0 To WaitTime
        DoEvents
    Next P
    
End Sub
Public Function CRC32(Str As String) As Long
    Dim i As Long, j As Long, nCRC As Long
    Dim nByte As Integer
    Dim nBit As Boolean
  
    Static nPowers(0 To 7) As Integer
  
    If nPowers(0) = 0 Then
        For i = 0 To 7
            nPowers(i) = 2 ^ i
        Next i
    End If
    
    For i = 1 To Len(Str)
        nByte = Asc(mID$(Str, i, 1))
    
        For j = 7 To 0 Step -1
            nBit = CBool((nCRC And 32768) = 32768) Xor ((nByte And nPowers(j)) = nPowers(j))
            nCRC = (nCRC And 32767&) * 2&
      
            If nBit Then nCRC = nCRC Xor &H8005&
        Next j
    Next i
  
    CRC32 = nCRC

End Function
Public Function Get_ProcessorFamily(ByVal strValue As String) As String
    Dim sType As String
            
    Select Case strValue
        Case "1":  sType = "Other"
        Case "2":  sType = "Unknown"
        Case "3":  sType = "8086"
        Case "4":  sType = "80286"
        Case "5":  sType = "80386"
        Case "6":  sType = "80486"
        Case "7":  sType = "8087"
        Case "8":  sType = "80287"
        Case "9":  sType = "80387"
        Case "10": sType = "80487"
        Case "11": sType = "Pentium brand"
        Case "12": sType = "Pentium Pro"
        Case "13": sType = "Pentium II"
        Case "14": sType = "Pentium processor with MMX technology"
        Case "15": sType = "Celeron"
        Case "16": sType = "Pentium II Xeon"
        Case "17": sType = "Pentium III"
        Case "18": sType = "M1 Family"
        Case "19": sType = "M2 Family"
        Case "24": sType = "K5 Family"
        Case "25": sType = "K6 Family"
        Case "26": sType = "K6-2"
        Case "27": sType = "K6-3"
        Case "28": sType = "AMD Athlon Processor Family"
        Case "29": sType = "AMD Duron Processor"
        Case "30": sType = "AMD29000 Family"
        Case "31": sType = "K6-2+"
        Case "32": sType = "Power PC Family"
        Case "33": sType = "Power PC 601"
        Case "34": sType = "Power PC 603"
        Case "35": sType = "Power PC 603+"
        Case "36": sType = "Power PC 604"
        Case "37": sType = "Power PC 620"
        Case "38": sType = "Power PC X704"
        Case "39": sType = "Power PC 750"
        Case "48": sType = "Alpha Family"
        Case "49": sType = "Alpha 21064"
        Case "50": sType = "Alpha 21066"
        Case "51": sType = "Alpha 21164"
        Case "52": sType = "Alpha 21164PC"
        Case "53": sType = "Alpha 21164a"
        Case "54": sType = "Alpha 21264"
        Case "55": sType = "Alpha 21364"
        Case "64": sType = "MIPS Family"
        Case "65": sType = "MIPS R4000"
        Case "66": sType = "MIPS R4200"
        Case "67": sType = "MIPS R4400"
        Case "68": sType = "MIPS R4600"
        Case "69": sType = "MIPS R10000"
        Case "80": sType = "SPARC Family"
        Case "81": sType = "SuperSPARC"
        Case "82": sType = "microSPARC II"
        Case "83": sType = "microSPARC IIep"
        Case "84": sType = "UltraSPARC"
        Case "85": sType = "UltraSPARC II"
        Case "86": sType = "UltraSPARC IIi"
        Case "87": sType = "UltraSPARC III"
        Case "88": sType = "UltraSPARC IIIi"
        Case "96": sType = "68040"
        Case "97": sType = "68xxx Family"
        Case "98": sType = "68000"
        Case "99": sType = "68010"
        Case "100": sType = "68020"
        Case "101": sType = "68030"
        Case "112": sType = "Hobbit Family"
        Case "120": sType = "Crusoe TM5000 Family"
        Case "121": sType = "Crusoe TM3000 Family"
        Case "122": sType = "Efficeon8000 Family"
        Case "128": sType = "Weitek"
        Case "130": sType = "Itanium Processor"
        Case "131": sType = "AMD Athlon"
        Case "132": sType = "AMD Opteron Family"
        Case "144": sType = "PA-RISC Family"
        Case "145": sType = "PA-RISC 8500"
        Case "146": sType = "PA-RISC 8000"
        Case "147": sType = "PA-RISC 7300LC"
        Case "148": sType = "PA-RISC 7200"
        Case "149": sType = "PA-RISC 7100LC"
        Case "150": sType = "PA-RISC 7100"
        Case "160": sType = "V30 Family"
        Case "176": sType = "Pentium III Xeon"
        Case "177": sType = "Pentium III Processor with Intel SpeedStep Technology"
        Case "178": sType = "Pentium 4"
        Case "179": sType = "Intel Xeon"
        Case "180": sType = "AS400 Family"
        Case "181": sType = "Intel Xeon processor MP"
        Case "182": sType = "AMD AthlonXP Family"
        Case "183": sType = "AMD AthlonMP Family"
        Case "184": sType = "Intel Itanium 2"
        Case "185": sType = "Intel Pentium M Processor"
        Case "190": sType = "K7"
        Case "200": sType = "IBM390 Family"
        Case "201": sType = "G4"
        Case "202": sType = "G5"
        Case "203": sType = "G6"
        Case "204": sType = "z/Architecture base"
        Case "205": sType = "i860"
        Case "251": sType = "i960"
        Case "260": sType = "SH-3"
        Case "261": sType = "SH-4"
        Case "280": sType = "ARM"
        Case "281": sType = "StrongARM"
        Case "300": sType = "6x86"
        Case "301": sType = "MediaGX"
        Case "302": sType = "MII"
        Case "320": sType = "WinChip"
        Case "350": sType = "DSP"
        Case "500": sType = "V"
        
        Case Else:  sType = "Unknown"
    End Select
        
    Get_ProcessorFamily = sType

End Function
Public Function Get_ProcessorStatus(ByVal strValue As String) As String
    Dim sType As String
    
    Select Case strValue
        Case "1": sType = "Other"
        Case "2": sType = "Unknown"
        Case "3": sType = "Enabled"
        Case "4": sType = "Disabled"
        Case "5": sType = "Not Applicable"
    End Select
    
    Get_ProcessorStatus = sType

End Function
Public Function Get_ProcessorType(ByVal strValue As String) As String
    Dim sType As String
    
    Select Case strValue
        Case "1": sType = "Other"
        Case "2": sType = "Unknown"
        Case "3": sType = "Central Processor"
        Case "4": sType = "Math Processor"
        Case "5": sType = "DSP Processor"
        Case "6": sType = "Video Processor"
    End Select

    Get_ProcessorType = sType

End Function
Public Function VideoAdapter_Bytes2String(Bytes As Currency) As String
    Dim EinheitName() As Variant, EinheitFormat() As Variant
    Dim i As Integer

    EinheitName = ARRAY("Byte", "Byte", "Byte", "KB", "KB", "KB", "MB", "MB", "MB", "GB", "GB", "GB", "TB", "TB", "TB")
    EinheitFormat = ARRAY("0", "0", "0", "0.00", "0.0", "0.0", "0.00", "00.0", "0.0", "0.00", "0.0", "0.0", "0.00", "0.0", "0.0")

    i = Int(VideoAdapter_Log10(Bytes))
    VideoAdapter_Bytes2String = Format$(Bytes / 1024 ^ Int(i / 3), EinheitFormat(i)) & " " & EinheitName(i)

End Function
Public Static Function VideoAdapter_Log10(x As Currency) As Currency
    
    If x = 0 Then
        VideoAdapter_Log10 = 0
    Else
        VideoAdapter_Log10 = Log(x) / Log(10#)
    End If

End Function
Public Function Get_VideoMemoryType(ByVal strValue As String) As String
    Dim sType As String
    
    Select Case strValue
        Case "1":  sType = "Other"
        Case "2":  sType = "Unknown"
        Case "3":  sType = "VRAM"
        Case "4":  sType = "DRAM"
        Case "5":  sType = "SRAM"
        Case "6":  sType = "WRAM"
        Case "7":  sType = "EDO RAM"
        Case "8":  sType = "Burst Synchronous DRAM"
        Case "9":  sType = "Pipelined Burst SRAM"
        Case "10": sType = "CDRAM"
        Case "11": sType = "3DRAM"
        Case "12": sType = "SDRAM"
        Case "13": sType = "SGRAM"
    End Select
    
    Get_VideoMemoryType = sType

End Function
Public Function Get_Availability(ByVal strValue As String) As String
    Dim sType As String
    
    Select Case strValue
        Case "1":  sType = "Other"
        Case "2":  sType = "Unknown"
        Case "3":  sType = "Running/Full Power"
        Case "4":  sType = "Warning"
        Case "5":  sType = "In Test"
        Case "6":  sType = "Not Applicable"
        Case "7":  sType = "Power Off"
        Case "8":  sType = "Off Line"
        Case "9":  sType = "Off Duty"
        Case "10": sType = "Degraded"
        Case "11": sType = "Not Installed"
        Case "12": sType = "Install Error / Power Save - Unkown"
        Case "13": sType = "The device is known to be in a power save mode, but its exact status is unkown"
        Case "14": sType = "The device is in a power save state but still functioning, and may exhibit degraded performance. / Power Save - Standby"
        Case "15": sType = "The device is not functioning but could be brought to full power quickly."
        Case "16": sType = "Power Cycle / Power Save - Warning"
        Case "17": sType = "The device is in a warning state, though also in a power save mode."
    End Select
    
    Get_Availability = sType

End Function
Public Function Get_VideoArchitecture(ByVal strValue As String) As String
    Dim sType As String
    
    Select Case strValue
        Case "1": sType = "Other"
        Case "2": sType = "Unknown"
        Case "3": sType = "CGA"
        Case "4": sType = "EGA"
        Case "5": sType = "VGA"
        Case "6": sType = "SVGA"
        Case "7": sType = "MDA"
        Case "8": sType = "HGC"
        Case "9": sType = "MCGA"
        Case "10": sType = "8514A"
        Case "11": sType = "XGA"
        Case "12": sType = "Linear Frame Buffer"
        Case "13": sType = "PC-98"
    End Select
    
    Get_VideoArchitecture = sType

End Function
Public Function Crypt(strOriginal As String, strPassword As String, _
                      Encrypting As Boolean) As String
    Dim valPass As Long, valString As Long, x As Long
    
    For x = 1 To Len(strPassword)
        valPass = valPass + Asc(mID$(strPassword, x, 1)) + 13
    Next x
    
    For x = 1 To Len(strOriginal)
        If Encrypting = True Then
            valString = Asc(mID$(strOriginal, x, 1)) + valPass + (x ^ 2)
            
            Do While valString > 255
                valString = valString - 255
            Loop
        Else 'if decrypting
            valString = Asc(mID$(strOriginal, x, 1)) - valPass - (x ^ 2)
            
            Do While valString <= 0
                valString = valString + 255
            Loop
        End If
        
        Crypt = Crypt & Chr(valString)
    Next x
    
End Function
Public Function NB_EnumLanAdapter(bLanArray() As Byte) As Long
    Dim myNcb As NCB
    Dim bRetEnum As ENUM_LANA
    
    Const NCBENUM As Byte = &H37
    
    myNcb.ncb_Command = NCBENUM
    myNcb.ncb_pBuffer = VarPtr(bRetEnum)
    myNcb.ncb_Length = Len(bRetEnum)
    
    If Netbios(myNcb) = NRC_GOODRET Then
        If bRetEnum.bCount Then
            NB_EnumLanAdapter = CLng(bRetEnum.bCount)
            
            ReDim bLanArray(0 To bRetEnum.bCount)
            
            CopyMemory_ByRef bLanArray(1), bRetEnum.bLana(0), bRetEnum.bCount
        End If
    End If
    
End Function
Public Function NB_ResetAdapter(lLanNumber As Byte, lSessions As Long, _
                                lMaxNames As Long) As Long
    Dim myNcb As NCB
    
    Const NCBRESET As Byte = &H32
    
    myNcb.ncb_Lana_Num = lLanNumber
    myNcb.ncb_Command = NCBRESET
    myNcb.ncb_LSN = 0

    Mid$(myNcb.ncb_CallName, 1, 1) = Chr$(lSessions)
    Mid$(myNcb.ncb_CallName, 3, 1) = Chr$(lMaxNames)
    
    If Netbios(myNcb) = NRC_GOODRET Then NB_ResetAdapter = 1

End Function
Public Function NB_GetMACAddress(lLanNumber As Byte, Optional PCname As String = "*") As String
    Dim myNcb As NCB
    Dim myASTAT As ASTAT
    
    Const NCBASTAT As Byte = &H33
    
    myNcb.ncb_Command = NCBASTAT
    myNcb.ncb_Lana_Num = lLanNumber
    myNcb.ncb_CallName = PCname
    myNcb.ncb_Length = Len(myASTAT)
    myNcb.ncb_pBuffer = VarPtr(myASTAT)
    
    If Netbios(myNcb) = NRC_GOODRET Then
        NB_GetMACAddress = HexEx(myASTAT.adapt.adapter_address(0)) & "-" & _
                           HexEx(myASTAT.adapt.adapter_address(1)) & "-" & _
                           HexEx(myASTAT.adapt.adapter_address(2)) & "-" & _
                           HexEx(myASTAT.adapt.adapter_address(3)) & "-" & _
                           HexEx(myASTAT.adapt.adapter_address(4)) & "-" & _
                           HexEx(myASTAT.adapt.adapter_address(5))
    End If
    
End Function
Private Function HexEx(ByVal lNumber As Long) As String
    
    HexEx = Hex(lNumber)
    
    If Len(HexEx) = 1 Then HexEx = "0" & HexEx

End Function
Public Sub GetAllSubDirs(ByVal Path As String, _
                         ShowProgress As Boolean, frm As Object)
    Dim File As String, NewPath As String
    Dim hFile As Long
    Dim FD As WIN32_FIND_DATA
    
    Path = GetDir(Path)
    
    hFile = FindFirstFile(Path & "*.*", FD)
    If hFile <= 0 Then Exit Sub
    
    Do
        File = VBA.Left$(FD.cFileName, InStr(FD.cFileName, Chr$(0)) - 1)
              
        If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
            If (File <> ".") And (File <> "..") Then
                NewPath = Path & File
                
                If ShowProgress Then
                    frm.Message.Caption = DLL.CRTL.Control_CompactPath(frm.Message, NewPath)
                    frm.Message.Refresh
                    
                    DoEvents
                End If
                    
                Call DLL.ARRAY.Add(Dirs, NewPath, arTOEND)
                
                Call GetAllSubDirs(NewPath, ShowProgress, frm)
            End If
       End If
    Loop While FindNextFile(hFile, FD)
        
    Call FindClose(hFile)
        
End Sub
Public Function getDrive(ByVal Drive As String, Optional Check As Boolean = True) As String
       
    Select Case Len(Drive)
        Case 0, Is > 3
            Exit Function
        Case 1
            'Nope
        Case 2
            If Right$(Drive, 1) <> ":" Then Exit Function
        Case 3
            If mID(Drive, 2, 2) <> ":\" Then Exit Function
    End Select
    
    Drive = Left$(Drive, 1)
    Drive = UCase$(Drive)
    
    If Check Then
        If InStr(DLL.Drive.Get_AllDrives, Drive) = 0 Then Exit Function
    End If
    
    Drive = Drive & ":\"

    getDrive = Drive
    
End Function

